package io.swagger.client.api {

import io.swagger.common.ApiInvoker;
import io.swagger.exception.ApiErrorCodes;
import io.swagger.exception.ApiError;
import io.swagger.common.ApiUserCredentials;
import io.swagger.event.Response;
import io.swagger.common.SwaggerApi;
import io.swagger.client.model.InlineResponse200;
import io.swagger.client.model.InlineResponse2001;
import io.swagger.client.model._;
import io.swagger.client.model.InlineResponse2004;
import io.swagger.client.model.InlineResponse2005;
import io.swagger.client.model.InlineResponse2006;
import io.swagger.client.model.InlineResponse20010;
import io.swagger.client.model.InlineResponse20014;

import mx.rpc.AsyncToken;
import mx.utils.UIDUtil;
import flash.utils.Dictionary;
import flash.events.EventDispatcher;

public class DefaultApi extends SwaggerApi {
    /**
    * Constructor for the DefaultApi api client
    * @param apiCredentials Wrapper object for tokens and hostName required towards authentication
    * @param eventDispatcher Optional event dispatcher that when provided is used by the SDK to dispatch any Response
    */
    public function DefaultApi(apiCredentials: ApiUserCredentials, eventDispatcher: EventDispatcher = null) {
        super(apiCredentials, eventDispatcher);
    }

        public static const event_balance_get: String = "balance_get";
        public static const event_balance_lic_get: String = "balance_lic_get";
        public static const event_billing_debt_get: String = "billing_debt_get";
        public static const event_billing_info_get: String = "billing_info_get";
        public static const event_billing_limits_get: String = "billing_limits_get";
        public static const event_dns_prolong_list_get: String = "dns_prolong_list_get";
        public static const event_email_add_get: String = "email_add_get";
        public static const event_email_alias_delete_get: String = "email_alias_delete_get";
        public static const event_email_alias_list_get: String = "email_alias_list_get";
        public static const event_email_delete_get: String = "email_delete_get";
        public static const event_email_list_get: String = "email_list_get";
        public static const event_updates_last_get: String = "updates_last_get";
        public static const event_updates_list_get: String = "updates_list_get";
        public static const event_website_delete_get: String = "website_delete_get";
        public static const event_website_list_get: String = "website_list_get";


    /*
     * Returns Number 
     */
    public function balance_get (token_: String): String {
        // create path and map variables
        var path: String = "/balance".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "balance_get";

        token.returnType = Number;
        return requestId;

    }

    /*
     * Returns Number 
     */
    public function balance_lic_get (token_: String): String {
        // create path and map variables
        var path: String = "/balance.lic".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "balance_lic_get";

        token.returnType = Number;
        return requestId;

    }

    /*
     * Returns Array 
     */
    public function billing_debt_get (token_: String): String {
        // create path and map variables
        var path: String = "/billing/debt".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "billing_debt_get";

        token.returnType = Array;
        return requestId;

    }

    /*
     * Returns Array 
     */
    public function billing_info_get (token_: String): String {
        // create path and map variables
        var path: String = "/billing/info".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "billing_info_get";

        token.returnType = Array;
        return requestId;

    }

    /*
     * Returns _ 
     */
    public function billing_limits_get (token_: String): String {
        // create path and map variables
        var path: String = "/billing/limits".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "billing_limits_get";

        token.returnType = _;
        return requestId;

    }

    /*
     * Returns Array 
     */
    public function dns_prolong_list_get (token_: String): String {
        // create path and map variables
        var path: String = "/dns/prolong/list".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "dns_prolong_list_get";

        token.returnType = Array;
        return requestId;

    }

    /*
     * Returns String 
     */
    public function email_add_get (token_: String, addEmail: String): String {
        // create path and map variables
        var path: String = "/email/add".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(addEmail))
            queryParams["addEmail"] = toPathValue(addEmail);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "email_add_get";

        token.returnType = String;
        return requestId;

    }

    /*
     * Returns String 
     */
    public function email_alias_delete_get (token_: String, key_: String): String {
        // create path and map variables
        var path: String = "/email/alias/delete".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(key_))
            queryParams["key_"] = toPathValue(key_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "email_alias_delete_get";

        token.returnType = String;
        return requestId;

    }

    /*
     * Returns Array 
     */
    public function email_alias_list_get (token_: String): String {
        // create path and map variables
        var path: String = "/email/alias/list".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "email_alias_list_get";

        token.returnType = Array;
        return requestId;

    }

    /*
     * Returns String 
     */
    public function email_delete_get (token_: String, key_: String): String {
        // create path and map variables
        var path: String = "/email/delete".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(key_))
            queryParams["key_"] = toPathValue(key_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "email_delete_get";

        token.returnType = String;
        return requestId;

    }

    /*
     * Returns Array 
     */
    public function email_list_get (token_: String): String {
        // create path and map variables
        var path: String = "/email/list".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "email_list_get";

        token.returnType = Array;
        return requestId;

    }

    /*
     * Returns Number 
     */
    public function updates_last_get (token_: String): String {
        // create path and map variables
        var path: String = "/updates/last".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "updates_last_get";

        token.returnType = Number;
        return requestId;

    }

    /*
     * Returns Array 
     */
    public function updates_list_get (token_: String, key_: Number): String {
        // create path and map variables
        var path: String = "/updates/list".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(key_))
            queryParams["key_"] = toPathValue(key_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "updates_list_get";

        token.returnType = Array;
        return requestId;

    }

    /*
     * Returns String 
     */
    public function website_delete_get (token_: String, key_: String): String {
        // create path and map variables
        var path: String = "/website/delete".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(key_))
            queryParams["key_"] = toPathValue(key_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "website_delete_get";

        token.returnType = String;
        return requestId;

    }

    /*
     * Returns Array 
     */
    public function website_list_get (token_: String): String {
        // create path and map variables
        var path: String = "/website/list".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "website_list_get";

        token.returnType = Array;
        return requestId;

    }
}
}
