package io.swagger.client.api {

import io.swagger.common.ApiInvoker;
import io.swagger.exception.ApiErrorCodes;
import io.swagger.exception.ApiError;
import io.swagger.common.ApiUserCredentials;
import io.swagger.event.Response;
import io.swagger.common.SwaggerApi;

import mx.rpc.AsyncToken;
import mx.utils.UIDUtil;
import flash.utils.Dictionary;
import flash.events.EventDispatcher;

public class AuthAPIApi extends SwaggerApi {
    /**
    * Constructor for the AuthAPIApi api client
    * @param apiCredentials Wrapper object for tokens and hostName required towards authentication
    * @param eventDispatcher Optional event dispatcher that when provided is used by the SDK to dispatch any Response
    */
    public function AuthAPIApi(apiCredentials: ApiUserCredentials, eventDispatcher: EventDispatcher = null) {
        super(apiCredentials, eventDispatcher);
    }

        public static const event_auth_login_post: String = "auth_login_post";
        public static const event_auth_start_get: String = "auth_start_get";


    /*
     * Returns String 
     */
    public function auth_login_post (login: String, salt: String, response: String): String {
        // create path and map variables
        var path: String = "/auth/login".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(login))
            queryParams["login"] = toPathValue(login);
if("null" != String(salt))
            queryParams["salt"] = toPathValue(salt);
if("null" != String(response))
            queryParams["response"] = toPathValue(response);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "POST", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "auth_login_post";

        token.returnType = String;
        return requestId;

    }

    /*
     * Returns String 
     */
    public function auth_start_get (login: String): String {
        // create path and map variables
        var path: String = "/auth/start".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(login))
            queryParams["login"] = toPathValue(login);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "auth_start_get";

        token.returnType = String;
        return requestId;

    }
}
}
