package io.swagger.client.api {

import io.swagger.common.ApiInvoker;
import io.swagger.exception.ApiErrorCodes;
import io.swagger.exception.ApiError;
import io.swagger.common.ApiUserCredentials;
import io.swagger.event.Response;
import io.swagger.common.SwaggerApi;
import io.swagger.client.model.InlineResponse2003;
import io.swagger.client.model.InlineResponse2004;

import mx.rpc.AsyncToken;
import mx.utils.UIDUtil;
import flash.utils.Dictionary;
import flash.events.EventDispatcher;

public class DNSApi extends SwaggerApi {
    /**
    * Constructor for the DNSApi api client
    * @param apiCredentials Wrapper object for tokens and hostName required towards authentication
    * @param eventDispatcher Optional event dispatcher that when provided is used by the SDK to dispatch any Response
    */
    public function DNSApi(apiCredentials: ApiUserCredentials, eventDispatcher: EventDispatcher = null) {
        super(apiCredentials, eventDispatcher);
    }

        public static const event_dns_add_get: String = "dns_add_get";
        public static const event_dns_bind_get: String = "dns_bind_get";
        public static const event_dns_list_get: String = "dns_list_get";
        public static const event_dns_prolong_list_get: String = "dns_prolong_list_get";
        public static const event_dns_raw_get: String = "dns_raw_get";
        public static const event_dns_raw_managedmx_get: String = "dns_raw_managedmx_get";


    /*
     * Returns String 
     */
    public function dns_add_get (token_: String, addDnsZone: String, addDnsRecord: String, iisSiteForDns: String, bindOnly: Boolean): String {
        // create path and map variables
        var path: String = "/dns/add".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(addDnsZone))
            queryParams["addDnsZone"] = toPathValue(addDnsZone);
if("null" != String(addDnsRecord))
            queryParams["addDnsRecord"] = toPathValue(addDnsRecord);
if("null" != String(iisSiteForDns))
            queryParams["iisSiteForDns"] = toPathValue(iisSiteForDns);
if("null" != String(bindOnly))
            queryParams["bindOnly"] = toPathValue(bindOnly);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "dns_add_get";

        token.returnType = String;
        return requestId;

    }

    /*
     * Returns String 
     */
    public function dns_bind_get (token_: String, key_: Number, bindTo: String): String {
        // create path and map variables
        var path: String = "/dns/bind".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(key_))
            queryParams["key_"] = toPathValue(key_);
if("null" != String(bindTo))
            queryParams["bindTo"] = toPathValue(bindTo);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "dns_bind_get";

        token.returnType = String;
        return requestId;

    }

    /*
     * Returns Array 
     */
    public function dns_list_get (token_: String): String {
        // create path and map variables
        var path: String = "/dns/list".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "dns_list_get";

        token.returnType = Array;
        return requestId;

    }

    /*
     * Returns Array 
     */
    public function dns_prolong_list_get (token_: String): String {
        // create path and map variables
        var path: String = "/dns/prolong/list".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "dns_prolong_list_get";

        token.returnType = Array;
        return requestId;

    }

    /*
     * Returns String 
     */
    public function dns_raw_get (token_: String, key_: Number, sDel: Number, sAdd: Number, dnsType: String, dnsName: String, dnsValue: String): String {
        // create path and map variables
        var path: String = "/dns/raw".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(key_))
            queryParams["key_"] = toPathValue(key_);
if("null" != String(sDel))
            queryParams["sDel"] = toPathValue(sDel);
if("null" != String(sAdd))
            queryParams["sAdd"] = toPathValue(sAdd);
if("null" != String(dnsType))
            queryParams["dnsType"] = toPathValue(dnsType);
if("null" != String(dnsName))
            queryParams["dnsName"] = toPathValue(dnsName);
if("null" != String(dnsValue))
            queryParams["dnsValue"] = toPathValue(dnsValue);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "dns_raw_get";

        token.returnType = String;
        return requestId;

    }

    /*
     * Returns String 
     */
    public function dns_raw_managedmx_get (token_: String, key_: Number, managedMx: Number, updManagedMx: Number): String {
        // create path and map variables
        var path: String = "/dns/raw/managedmx".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(key_))
            queryParams["key_"] = toPathValue(key_);
if("null" != String(managedMx))
            queryParams["managedMx"] = toPathValue(managedMx);
if("null" != String(updManagedMx))
            queryParams["updManagedMx"] = toPathValue(updManagedMx);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "dns_raw_managedmx_get";

        token.returnType = String;
        return requestId;

    }
}
}
