package io.swagger.client.api {

import io.swagger.common.ApiInvoker;
import io.swagger.exception.ApiErrorCodes;
import io.swagger.exception.ApiError;
import io.swagger.common.ApiUserCredentials;
import io.swagger.event.Response;
import io.swagger.common.SwaggerApi;
import io.swagger.client.model.InlineResponse20011;
import io.swagger.client.model.InlineResponse20012;
import io.swagger.client.model.InlineResponse20013;

import mx.rpc.AsyncToken;
import mx.utils.UIDUtil;
import flash.utils.Dictionary;
import flash.events.EventDispatcher;

public class VDSHyperVOpenVZApi extends SwaggerApi {
    /**
    * Constructor for the VDSHyperVOpenVZApi api client
    * @param apiCredentials Wrapper object for tokens and hostName required towards authentication
    * @param eventDispatcher Optional event dispatcher that when provided is used by the SDK to dispatch any Response
    */
    public function VDSHyperVOpenVZApi(apiCredentials: ApiUserCredentials, eventDispatcher: EventDispatcher = null) {
        super(apiCredentials, eventDispatcher);
    }

        public static const event_vds_create_get: String = "vds_create_get";
        public static const event_vds_delete_get: String = "vds_delete_get";
        public static const event_vds_ip_add_get: String = "vds_ip_add_get";
        public static const event_vds_ip_delete_get: String = "vds_ip_delete_get";
        public static const event_vds_ip_list_get: String = "vds_ip_list_get";
        public static const event_vds_list_get: String = "vds_list_get";
        public static const event_vds_reboot_get: String = "vds_reboot_get";
        public static const event_vds_templates_list_get: String = "vds_templates_list_get";
        public static const event_vds_update_get: String = "vds_update_get";


    /*
     * Returns String 
     */
    public function vds_create_get (token_: String, type: String, crHvmem: Number, crHvdsk: Number, crHvcpu: Number, template: String, forceMemo: String, hv1gbPanelVersion: String, panelInstall: Boolean, crSsd1: Boolean, crHvAllSystem: Boolean): String {
        // create path and map variables
        var path: String = "/vds/create".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(type))
            queryParams["type"] = toPathValue(type);
if("null" != String(crHvmem))
            queryParams["crHvmem"] = toPathValue(crHvmem);
if("null" != String(crHvdsk))
            queryParams["crHvdsk"] = toPathValue(crHvdsk);
if("null" != String(crHvcpu))
            queryParams["crHvcpu"] = toPathValue(crHvcpu);
if("null" != String(template))
            queryParams["template"] = toPathValue(template);
if("null" != String(forceMemo))
            queryParams["forceMemo"] = toPathValue(forceMemo);
if("null" != String(hv1gbPanelVersion))
            queryParams["hv1gbPanelVersion"] = toPathValue(hv1gbPanelVersion);
if("null" != String(panelInstall))
            queryParams["panelInstall"] = toPathValue(panelInstall);
if("null" != String(crSsd1))
            queryParams["crSsd1"] = toPathValue(crSsd1);
if("null" != String(crHvAllSystem))
            queryParams["crHvAllSystem"] = toPathValue(crHvAllSystem);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "vds_create_get";

        token.returnType = String;
        return requestId;

    }

    /*
     * Returns String 
     */
    public function vds_delete_get (token_: String, key_: Number, forceCritical: Boolean): String {
        // create path and map variables
        var path: String = "/vds/delete".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(key_))
            queryParams["key_"] = toPathValue(key_);
if("null" != String(forceCritical))
            queryParams["forceCritical"] = toPathValue(forceCritical);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "vds_delete_get";

        token.returnType = String;
        return requestId;

    }

    /*
     * Returns String 
     */
    public function vds_ip_add_get (token_: String, key_: Number): String {
        // create path and map variables
        var path: String = "/vds/ip/add".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(key_))
            queryParams["key_"] = toPathValue(key_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "vds_ip_add_get";

        token.returnType = String;
        return requestId;

    }

    /*
     * Returns String 
     */
    public function vds_ip_delete_get (token_: String, key_: Number, delIp: String): String {
        // create path and map variables
        var path: String = "/vds/ip/delete".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(key_))
            queryParams["key_"] = toPathValue(key_);
if("null" != String(delIp))
            queryParams["delIp"] = toPathValue(delIp);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "vds_ip_delete_get";

        token.returnType = String;
        return requestId;

    }

    /*
     * Returns Array 
     */
    public function vds_ip_list_get (token_: String, key_: Number): String {
        // create path and map variables
        var path: String = "/vds/ip/list".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(key_))
            queryParams["key_"] = toPathValue(key_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "vds_ip_list_get";

        token.returnType = Array;
        return requestId;

    }

    /*
     * Returns Array 
     */
    public function vds_list_get (token_: String, key_: Number): String {
        // create path and map variables
        var path: String = "/vds/list".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(key_))
            queryParams["key_"] = toPathValue(key_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "vds_list_get";

        token.returnType = Array;
        return requestId;

    }

    /*
     * Returns String 
     */
    public function vds_reboot_get (token_: String, key_: Number): String {
        // create path and map variables
        var path: String = "/vds/reboot".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(key_))
            queryParams["key_"] = toPathValue(key_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "vds_reboot_get";

        token.returnType = String;
        return requestId;

    }

    /*
     * Returns Array 
     */
    public function vds_templates_list_get (token_: String): String {
        // create path and map variables
        var path: String = "/vds/templates-list".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "vds_templates_list_get";

        token.returnType = Array;
        return requestId;

    }

    /*
     * Returns String 
     */
    public function vds_update_get (token_: String, key_: Number, crHvmem: Number, crHvdsk: Number, crHvcpu: Number): String {
        // create path and map variables
        var path: String = "/vds/update".replace(/{format}/g,"xml");

        // query params
        var queryParams: Dictionary = new Dictionary();
        var headerParams: Dictionary = new Dictionary();

        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if(        // verify required params are set
        if() {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }
) {
            throw new ApiError(400, "missing required params");
        }

        if("null" != String(token_))
            queryParams["token_"] = toPathValue(token_);
if("null" != String(key_))
            queryParams["key_"] = toPathValue(key_);
if("null" != String(crHvmem))
            queryParams["crHvmem"] = toPathValue(crHvmem);
if("null" != String(crHvdsk))
            queryParams["crHvdsk"] = toPathValue(crHvdsk);
if("null" != String(crHvcpu))
            queryParams["crHvcpu"] = toPathValue(crHvcpu);

        
        var token:AsyncToken = getApiInvoker().invokeAPI(path, "GET", queryParams, null, headerParams);

        var requestId: String = getUniqueId();

        token.requestId = requestId;
        token.completionEventType = "vds_update_get";

        token.returnType = String;
        return requestId;

    }
}
}
